----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:56:06 08/05/2006 
-- Design Name: 
-- Module Name:    ntop - RTL 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BRAMBLOCK is
 generic (
      BITWIDTH   : integer := 8;
			DATAOUT		 : integer := 8;
  		COUNTER_BITWIDTH   : integer := 15
			);
   port ( CLK 			: in    std_logic; 
					RST 			: in    std_logic; 
					DIN			 	: in    std_logic_vector(BITWIDTH-1 downto 0);
					EN				: in		std_logic;
          WE				:	in		std_logic;
					ENABLE_CNT	: in		std_logic;
					UP				: in		std_logic;
					DOWN			: in		std_logic;
					OVF_BRAMBLOCK	: out   std_logic;
					DOUT  		: out   std_logic_vector (DATAOUT-1 downto 0)
			 );
end BRAMBLOCK;

architecture RTL of BRAMBLOCK is
signal enrambank_int : std_logic_vector(1 downto 0);
signal werambank_int : std_logic_vector(1 downto 0);
signal adress_cnt_int : std_logic_vector(COUNTER_BITWIDTH-1 downto 0);
signal ram_out_int : std_logic_vector(15 downto 0);

	component Block_ram
	port (	clk            : in  std_logic;
					en             : in  std_logic;
					ADRESSE        : in  std_logic_vector(13 downto 0);
					DB_I           : in  std_logic_vector(7 downto 0);
					DB_O           : out std_logic_vector(7 downto 0);
					we             : in  std_logic
				);
	end component;

component bank_select 
port (		banksel		: in    std_logic;
					REN				: in		std_logic;
					RWE				: in		std_logic;					
					ENRAMBANK	: out   std_logic_vector(1 downto 0);
					WERAMBANK :	out   std_logic_vector(1 downto 0)
			);
end component;

component adress_counter 
port ( 		RST    		: in    std_logic; 
					CLK 			: in    std_logic; 
					CNT			 	: out   std_logic_vector(COUNTER_BITWIDTH-1 downto 0);
    			UP				: in		std_logic;
					DOWN			: in		std_logic;
					OVF    		: out   std_logic; 
					EN    		: in    std_logic 
			);
end component;

component d_mux16to8 
port (		BANKSEL		:	in		std_logic;
					DIN				: in    std_logic_vector(15 downto 0);
					DOUT			: out   std_logic_vector(7 downto 0)
			);
end component;		

begin

  RAM00 : Block_ram
      port map (clk=>CLK,
                en=>enrambank_int(0),
                ADRESSE=> adress_cnt_int(13 downto 0),
								DB_I=>DIN,
                we=>werambank_int(0),
                DB_O=>ram_out_int(7 downto 0));
 
	RAM01 : Block_ram
      port map (clk=>CLK,
                en=>enrambank_int(1),
                ADRESSE=>adress_cnt_int(13 downto 0),
								DB_I=>DIN,
                we=>werambank_int(1),
                DB_O=>ram_out_int(15 downto 8));
		
	BANKSEL: bank_select
			port map (banksel=>adress_cnt_int(14),
								REN=>EN,
								RWE=>WE,
								ENRAMBANK(0)=>enrambank_int(0),
								ENRAMBANK(1)=>enrambank_int(1),
								WERAMBANK(0)=>werambank_int(0),
								WERAMBANK(1)=>werambank_int(1)
					);
			
	RADRESS: adress_counter
	port map (		RST=>RST,
								CLK=>CLK,
								UP=>UP,
								DOWN=>DOWN,
								CNT=>adress_cnt_int,
								OVF=>OVF_BRAMBLOCK,
								EN=>ENABLE_CNT
					);
	D_MUX: d_mux16to8
	port map(		BANKSEL=> adress_cnt_int(14),
							DIN(7 downto 0)=>ram_out_int(7 downto 0),
							DIN(15 downto 8)=>ram_out_int(15 downto 8),
							DOUT=>DOUT
					);

end RTL;



