----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:57:37 07/30/2006 
-- Design Name: 
-- Module Name:    uuu - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Block_ram is
 
	port (
      clk            : in  std_logic;
      en             : in  std_logic;
      ADRESSE        : in  std_logic_vector(13 downto 0);
      DB_I           : in  std_logic_vector(7 downto 0);
      DB_O           : out std_logic_vector(7 downto 0);
      we             : in  std_logic
   );

end entity Block_ram;

architecture RTL of Block_ram is



   constant BIT_DEPTH      : positive  := 16384;
   constant BIT_WIDTH      : positive  := 8;
   
   type ram_t is array(BIT_DEPTH-1 downto 0)
      of std_logic_vector(BIT_WIDTH-1 downto 0);

   -- infer RAM
   signal blockram   : ram_t; 

begin 

   process (clk)
   begin
  
	    if rising_edge(clk) then  
       if(en = '1') then  
         if (we = '1') then
           blockram(conv_integer(ADRESSE)) <= DB_I;
           DB_O <= DB_I;
         else
           DB_O <= blockram(conv_integer(ADRESSE));
         end if;
       end if;
     end if;

   end process;

end RTL;



