----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    01:29:43 08/12/2006 
-- Design Name: 
-- Module Name:    Blockram_crtl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Blockram_crtl is
 generic (
      BRAMBLOCK_BITWIDTH  		: integer := 8;
			BRAMBLOCK_DATAOUT				: integer := 64;
			BRAMBLOCK_RAMQTY				: integer := 16;
			D_MUX_BITWIDTH   				: integer := 128;
			D_MUX_DBITWIDTH  				: integer := 8;
			D_MUX_RAMQTY						:	integer	:= 16; 
			ADRESS_COUNTER_BITWIDTH	: integer := 15
	 );

port (		CLK				: in std_logic;
					RST				: in std_logic;
					DATAIN		: in std_logic_vector(7 downto 0);
					DATAOUT		: out std_logic_vector(7 downto 0);
					OVF_OUT		: out   std_logic;
					RW				:	in std_logic_vector(1 downto 0)
					
			);

end Blockram_crtl;

architecture Behavioral of Blockram_crtl is

signal en_int : std_logic;
signal we_int : std_logic;
signal up_int : std_logic;
signal down_int : std_logic;
signal enable_cnt_int : std_logic;

component BRAMBLOCK	
	port (  CLK						: in    std_logic; 
					RST 					: in    std_logic; 
					DIN			 			: in    std_logic_vector(7 downto 0);
					EN						: in		std_logic;
          WE						: in		std_logic;
					UP						: in		std_logic;
					DOWN					: in		std_logic;
					OVF_BRAMBLOCK	: out   std_logic;
					ENABLE_CNT		: in		std_logic;
					DOUT  				: out   std_logic_vector (7 downto 0)
				);
end component;
					

begin


	RAM : BRAMBLOCK
	port map (  CLK=>CLK,
							RST=>RST,
							OVF_BRAMBLOCK=>OVF_OUT,
							DIN=>DATAIN,
							UP=>up_int,
							DOWN=>down_int,
							EN=>en_int,
							WE=>we_int,
							ENABLE_CNT=>enable_cnt_int,
							DOUT=>DATAOUT
					);


process(CLK) begin
	if rising_edge(CLK) then
		if rst = '1' then										-- sync. rst
				we_int <= '0';
				en_int <= '0';	 
				enable_cnt_int <= '0';
			else
			case RW is 
				when "00" =>
					we_int <= '0';
					en_int <= '0';	 
					enable_cnt_int <= '0';
					up_int <= '0';
					down_int <= '0';
				when "01" =>				-- READ
					we_int <= '0';
					en_int <= '1';
					enable_cnt_int <= '1';
					up_int <= '0';
					down_int <= '1';
				when "10" =>
					we_int <= '1';
					en_int <= '1';
					enable_cnt_int <= '1';
					up_int <= '1';
					down_int <= '0';
				when others =>
					we_int <= '0';
					en_int <= '0';
					up_int <= '0';
					down_int <= '0';
					enable_cnt_int <= '0';
			end case;
		end if;
 end if;
end process;
end Behavioral;

