----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:04:28 08/11/2006 
-- Design Name: 
-- Module Name:    Blockramstage - RTL 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Blockramstage is
 generic (
      BITWIDTH   : integer := 8
	 );
   port ( CLK 			: in    std_logic; 
					ADRESSE   : in  	std_logic_vector(13 downto 0);
					DIN			 	: in    std_logic_vector(BITWIDTH-1 downto 0);
          RW    		: in    std_logic; 
          DOUT  		: out   std_logic_vector (BITWIDTH-1 downto 0));

end Blockramstage;

architecture RTL of Blockramstage is
signal bramblocken_int : std_logic_vector(1 downto 0);

   component BRAMBLOCK
	 port ( CLK 			: in    std_logic; 
					ADRESSE   : in  	std_logic_vector(13 downto 0);
					DIN			 	: in    std_logic_vector(BITWIDTH-1 downto 0);
          WE    		: in    std_logic; 
					EN				: in    std_logic; 
          DOUT  		: out   std_logic_vector (DATAOUT-1 downto 0));
	end component;

component bank_select
	 port (	banksel		: in    std_logic;
					rambank0	: out   std_logic;
					rambank1	: out   std_logic);
	end component;

 
   
begin
BRAM0 : BRAMBLOCK
      port map (clk=>CLK,
                en=>rambank0,
                ADRESSE=>ADRESSE,
								DB_I=>DIN,
                we=>rambank0,
                DB_O=>DOUT(7 downto 0));
 
BRAM1 : BRAMBLOCK
      port map (clk=>CLK,
                en=>rambank1,
                ADRESSE=>ADRESSE,
								DB_I=>DIN,
                we=>rambank1,
                DB_O=>DOUT(7 downto 0));


end RTL;

