library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_ARITH.ALL; 
--use ieee.numeric_std.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;


entity adress_counter is
generic (	BITWIDTH: integer := 15;
					TRIGGER:	integer := 32767
				);

port ( 		RST    		: in    std_logic; 
					CLK 			: in    std_logic; 
					UP	 			: in    std_logic; 
					DOWN 			: in    std_logic; 
					CNT			 	: out   std_logic_vector(BITWIDTH-1 downto 0);
    			OVF    		: out   std_logic; 
					EN    		: in    std_logic 
			);
end adress_counter;

architecture Behavioral of adress_counter is

signal cnt_int: std_logic_vector(BITWIDTH-1 downto 0); 			-- Adresszaehler
signal ovf_int: std_logic;

begin

process(rst,clk,cnt_int,ovf_int,up,down) 

begin

if rising_edge(CLK) then											-- rising edge 
	if rst = '1' then														-- async. rst
		cnt_int <= (others=>'0');
		ovf_int <= '0';														-- clear ovf flag
	else
	if EN = '1' then 														-- enable															
		if up = '1' then
			cnt_int <= cnt_int + 1; 	
		elsif down = '1' then	
			cnt_int <= cnt_int - 1;
		end if;
		if cnt_int = TRIGGER then
				ovf_int <= '1';												-- set ovf flag
			else
				ovf_int <= '0';	
			end if;	
				
			end if;
		end if;		
	end if;		

end process;
CNT <= cnt_int;	
OVF <= ovf_int;
end Behavioral;

